import os
from services.basicservice import BasicService
from servicestub import ServiceStub
from singleton import Singleton
from configparser import ConfigParser
from bottle import request

class Mindbox(BasicService, metaclass=Singleton):
    
    def __init__(self):
        super().__init__(os.path.dirname(os.path.abspath(__file__)))
    
    def registerRoutes(self, servicestub: ServiceStub):
        self.log.info('Регистрация сервиса Mindbox')
        self._loadCases('cases.json')
        
        conf = ConfigParser()
        conf.read(os.path.join(os.path.dirname(os.path.abspath(__file__)), 'confg.ini'))

        self.servicePath = conf.get('mindbox', 'path') if conf.has_option('mindbox', 'path') else '/mindbox'
        servicestub.route( f'{self.servicePath}/<path:re:.*>', method='POST', callback=self.req)
    
    def req(self, path):
        operation = request.query.get('operation')
        self.log.info(f"Операция: {operation}")
        return self._createResponse(operation)

instance = Mindbox()
