import os
from services.basicservice import BasicService
from servicestub import ServiceStub
from singleton import Singleton
from configparser import ConfigParser


class Uds(BasicService, metaclass=Singleton):
    
    def __init__(self):
        super().__init__(os.path.dirname(os.path.abspath(__file__)))
    
    def registerRoutes(self, servicestub: ServiceStub):
        self.log.info('Регистрация сервиса UDS')
        self._loadCases('cases.json')
        
        conf = ConfigParser()
        conf.read(os.path.join(os.path.dirname(os.path.abspath(__file__)), 'config.ini'))

        self.servicePath = conf.get('uds', 'path') if conf.has_option('uds', 'path') else '/uds'
        servicestub.route( f'{self.servicePath}/<path:re:.*>', method='GET', callback=self.req)
        servicestub.route( f'{self.servicePath}/<path:re:.*>', method='POST', callback=self.req)
    
    def req(self,path):
        self.log.info(f"Операция: {path}")
        return self._createResponse(path)

instance = Uds()
